
Texture2D tex <string uiname="Texture 2D";>;

RWStructuredBuffer<float> gOutput1 : BACKBUFFER;
RWStructuredBuffer<float2> gOutput2 : BACKBUFFER;
RWStructuredBuffer<float3> gOutput3 : BACKBUFFER;
RWStructuredBuffer<float4> gOutput4 : BACKBUFFER;

int2 res;

// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================

[numthreads(64, 1, 1)]
void WriteFloat_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y) return;
	
	uint index = DTid.x + DTid.y * res.x;
	gOutput1[index] = tex.Load(DTid).x;
}

[numthreads(64, 1, 1)]
void WriteFloat2_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y) return;
	
	uint index = DTid.x + DTid.y * res.x;
	gOutput2[index] = tex.Load(DTid).xy;
}

[numthreads(64, 1, 1)]
void WriteFloat3_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y) return;
	
	uint index = DTid.x + DTid.y * res.x;
	gOutput3[index] = tex.Load(DTid).xyz;
}

[numthreads(64, 1, 1)]
void WriteFloat4_CS(	uint3 DTid : SV_DispatchThreadID)
{	
	if(	DTid.x >= res.x || 
		DTid.y >= res.y) return;

	uint index = DTid.x + DTid.y * res.x;
	gOutput4[index] = tex.Load(DTid);
}

// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================

technique11 Write_Buffer_float
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat_CS() ) );	}
}

technique11 Write_Buffer_float2
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat2_CS() ) );	}
}

technique11 Write_Buffer_float3
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat3_CS() ) );	}
}

technique11 Write_Buffer_float4
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat4_CS() ) );	}
}




