
Texture3D tex <string uiname="Texture 3D";>;

RWStructuredBuffer<float> gOutput1 : BACKBUFFER;
RWStructuredBuffer<float2> gOutput2 : BACKBUFFER;
RWStructuredBuffer<float3> gOutput3 : BACKBUFFER;
RWStructuredBuffer<float4> gOutput4 : BACKBUFFER;

int3 res;

// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================

[numthreads(8, 8, 1)]
void WriteFloat_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y || 
		DTid.z >= res.z) return;
	
	uint index = DTid.x + (DTid.y * res.x) + (DTid.z*res.x*res.y);
	
	gOutput1[index] = tex.Load(int4(DTid,0));
}

[numthreads(8, 8, 1)]
void WriteFloat2_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y || 
		DTid.z >= res.z) return;
	
	uint index = DTid.x + (DTid.y * res.x) + (DTid.z*res.x*res.y);
	
	gOutput2[index] = tex.Load(int4(DTid,0));
}

[numthreads(8, 8, 1)]
void WriteFloat3_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y || 
		DTid.z >= res.z) return;
	
	uint index = DTid.x + (DTid.y * res.x) + (DTid.z*res.x*res.y);
	
	gOutput3[index] = tex.Load(int4(DTid,0));
}

[numthreads(8, 8, 1)]
void WriteFloat4_CS(	uint3 DTid : SV_DispatchThreadID)
{
	if(	DTid.x >= res.x || 
		DTid.y >= res.y || 
		DTid.z >= res.z) return;
	
	uint index = DTid.x + (DTid.y * res.x) + (DTid.z*res.x*res.y);
	
	gOutput4[index] = tex.Load(int4(DTid,0));
}

// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================

technique11 Write_Buffer_float
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat_CS() ) );	}
}

technique11 Write_Buffer_float2
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat2_CS() ) );	}
}

technique11 Write_Buffer_float3
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat3_CS() ) );	}
}

technique11 Write_Buffer_float4
{
	pass P0
	{	SetComputeShader(CompileShader( cs_5_0, WriteFloat4_CS() ) );	}
}




