float4x4 tWVP: WORLDVIEWPROJECTION ;

Texture3D Texture;
SamplerState g_sam
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
    AddressW = Clamp;
};

cbuffer cbPerDraw : register( b0 )
{
	float z <string uiname="Texture3D slice Z coord";>;
	float4x4 tCol <string uiname="Color Transform";>;
};

// =============================================================================
// VERTEX SHADER ===============================================================
// =============================================================================

struct VS_IN
{
	float4 PosO : POSITION ;
	float2 TexCd : TEXCOORD0 ;

};

struct VS_OUT
{
    float4 PosWVP: SV_POSITION ;
    float2 TexCd: TEXCOORD0 ;
};

VS_OUT VS(VS_IN In)
{
    //inititalize all fields of output struct with 0
    VS_OUT Out = (VS_OUT)0;

    //position (projected)
    Out.PosWVP  = mul(In.PosO,tWVP);
    Out.TexCd = In.TexCd;
    return Out;
}


// =============================================================================
// PIXEL SHADER ================================================================
// =============================================================================

float4 PSV(VS_OUT In): SV_Target
{
    float4 col = Texture.Sample( g_sam, float3(In.TexCd,z));
	col = mul(col, tCol);
	
	return col;
}

// =============================================================================
// TECHNIQUES ==================================================================
// =============================================================================

technique11 process
{
	pass P0
	{
		SetHullShader( 0 );
		SetDomainShader( 0 );
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PSV() ) );
	}
}