float time;

float4x4 tW: WORLD ;
// NOISE:
#include "MattNoise.fxh"
float noiseGamma = 1;
float3 noisePosOffset;
float baseFreq = 1;

float2 res: TARGETSIZE;

// ============================================================================
// ============================================================================
// ============================================================================
// ============================================================================
// CLASSES

//Interfaces and Classes definitions
interface iNoiseType
{	float4 Noise(float3 pos); 	};

class cFBM : iNoiseType
{
   float4 Noise(float3 pos)
	{	return fBm(pos)+0.5;	}
};

class cTurbulence : iNoiseType
{
   float4 Noise(float3 pos)
   {	return turbulence(pos);	}
};

class cRidge : iNoiseType
{
   float4 Noise(float3 pos)
   {	return ridgedmf(pos);	}
};

cFBM Perlin;
cTurbulence Turbulence;
cRidge Ridge;

iNoiseType NoiseType <string linkclass="Perlin,Turbulence,Ridge";>;

// ============================================================================
// ============================================================================
// ============================================================================
// ============================================================================

struct VS_IN
{
	float4 PosO : POSITION;
	float2 TexCd : TEXCOORD0;

};

struct VS_OUT
{
    float4 PosWVP: SV_POSITION;
    float2 TexCd: TEXCOORD0;
};

// ============================================================================
// ============================================================================
// ============================================================================
// ============================================================================

VS_OUT VS(VS_IN In)
{
    //inititalize all fields of output struct with 0
    VS_OUT Out = (VS_OUT)0;

	float2 screenPos = In.PosO.xy;
	screenPos = mul(float4(screenPos,0,1), tW).xy;
	screenPos *= float2(res.y/res.x,1);
	
    //position (projected)
    Out.PosWVP  = float4(screenPos,0,1);
    //Out.PosWVP  = mul(float4(screenPos,0,1), tW);
    Out.TexCd = mul(float4(In.TexCd,0,1), tW).xy;
    return Out;
}

// ============================================================================
// ============================================================================
// ============================================================================
// ============================================================================

float4 PS_Tex(VS_OUT In): SV_Target
{
    float noise = saturate(NoiseType.Noise(float3(In.TexCd*baseFreq+noisePosOffset,time)));
	noise = pow(noise, noiseGamma);
	
    return noise;
}

// ============================================================================
// ============================================================================
// ============================================================================
// ============================================================================

technique11 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS_Tex() ) );
	}
}




