//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

StructuredBuffer<float3> position;

float thrs = 0.25;

struct VS_IN
{
	uint ii : SV_InstanceID;
	uint iv : SV_VertexID;
};

struct VS_OUT
{
    uint ii : TEXCOORD0;
	uint iv : TEXCOORD1;
};

struct GS_OUT
{
	float4 pos : SV_POSITION;
};

VS_OUT VS(VS_IN input)
{
	VS_OUT output;
	
	output.ii = input.ii;
	output.iv = input.iv;
	
    return output;
}

[maxvertexcount(2)]
void GS (point VS_OUT input[1], inout LineStream<GS_OUT> lines)
{
	GS_OUT output;

	float3 p0 = position[input[0].ii];
	float3 p1 = position[input[0].iv];
	
	float d = length (p0 - p1);
	if (d < thrs)
	{
		output.pos = mul (float4 (p0,1),  mul (tW, tVP));
		lines.Append(output);
		output.pos = mul (float4 (p1,1), mul (tW, tVP));
		lines.Append(output);
		lines.RestartStrip();
	}
}

float4 PS(GS_OUT input): SV_Target
{
    return 1;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




