//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2DArray tex <string uiname="Queue Texture";>;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

uint index = 0;

float time = 0;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
    float4 uv: TEXCOORD0;
};

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = mul(input.pos,mul(tW,tVP));
    output.uv = input.uv;
    return output;
}

float4 PS(VS_OUT input): SV_Target
{  
	return 1;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




