//@author: antokhio
//@help: template for geometry shaders
//@tags: GS, template
//@credits:

Texture2D tex <string uiname="Texture";>;

SamplerState s0: IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

float4x4 tW : WORLD;

int di : DRAWINDEX;
uint offset;
uint count = 40;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
};

struct GS_OUT
{
	float4 pos : SV_Position;
	float4 uv : TEXCOORD0;
	
};

VS_IN VS(VS_IN input)
{
	return input;
}

[maxvertexcount(3)]
void GS(triangle VS_IN input[3], inout TriangleStream<GS_OUT> gsout)
{ 
	GS_OUT output;
	for (int i = 0; i < 3; i++)
	{
		output.pos = input[i].pos;
		output.uv = input[i].uv;
	
		gsout.Append(output);
	}
	gsout.RestartStrip();
}


float4 PS(GS_OUT input): SV_Target
{
    return tex.Sample(s0,input.uv.xy);
}

technique10 Template
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader(CompileShader(gs_4_0,GS()));
    	SetPixelShader( CompileShader( ps_4_0, PS() ) );
    }  
}