float4x4 tWVP: WORLDVIEWPROJECTION;
float4x4 tVI : VIEWINVERSE;

float lenght = 1;
float noisePosScale = 0.5;
float noiseOffsetScale = 6;

float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
float time;

#include "noiseFunction.fxh"

#define maxExtrSegm 16
#define invMaxExtrSegm (float)1/maxExtrSegm+0.0001

struct vsInBuffer
{
	float4 posO : POSITION ;
    float4 normO: NORMAL ;
	uint iv : SV_VertexID;
};

struct gsIn
{
    float4 pos: POSITION ;
    float3 norm: NORMAL ;
}; 

struct psIn
{
	float4 pos: SV_POSITION;
    float2 uv: TEXCOORD01 ;
};


gsIn VSBuffer(vsInBuffer input)
{
    gsIn output;
    output.pos  = input.posO;
    output.norm  = input.normO.xyz;

    return output;
}
/*
[maxvertexcount(maxExtrSegm)]
void GS_extrude1(triangle gsIn input[3], inout TriangleStream<psIn> SpriteStream)
{
    psIn output;
    for(int i=0; i<maxExtrSegm; i++)
    {
        float3 position = input[0].pos.xyz + input[0].norm*i*lenght;

    	position += float3(	inoise(float4(position*noisePosScale,time)),
    						inoise(float4(position*noisePosScale,time+354.25)),
    						inoise(float4(position*noisePosScale,time-63.2))) * pow(i * invMaxExtrSegm, 0.5) * noiseOffsetScale ;

    	output.pos = mul( float4(position,1.0), tWVP );
    	
        output.uv = i * (1/(float)maxExtrSegm);
        SpriteStream.Append(output);
    }
    SpriteStream.RestartStrip();
}
*/
[maxvertexcount(maxExtrSegm*2)]
void GS_extrude2(line gsIn input[2], inout TriangleStream<psIn> SpriteStream)
{

	
	float3 pos0 = input[0].pos.xyz;
	float3 pos1 = input[1].pos.xyz;

	float extrLenght0 = inoise(float4(pos0*0.1,time))+0.25;
	extrLenght0 = clamp(extrLenght0,0,1);
	extrLenght0 *= maxExtrSegm*0.99;
	float extrLenght1 = inoise(float4(pos1*0.1,time))+0.25;
	extrLenght1 = clamp(extrLenght1,0,1);
	extrLenght1 *= maxExtrSegm*0.99;

    psIn output;
    for(int i=0; i<max(extrLenght0,extrLenght1) && abs(pos0.y-pos1.y)>0.1; i++)
    {
		float apicePhase = saturate(extrLenght0 - i);
   
        float3 position = input[0].pos.xyz + input[0].norm*min((i+apicePhase),extrLenght0)*lenght;
    	position += float3(	inoise(float4(position*noisePosScale,time)),
    						inoise(float4(position*noisePosScale,time+354.25)),
    						inoise(float4(position*noisePosScale,time-63.2))) * pow(min((i+apicePhase),extrLenght0) * invMaxExtrSegm, 0.5) * noiseOffsetScale ;

        output.pos = mul( float4(position,1.0), tWVP );
        output.uv = pow(abs(i* invMaxExtrSegm)+apicePhase*invMaxExtrSegm, .8);
        SpriteStream.Append(output);

    	
    	
    	apicePhase = saturate(extrLenght1 - i);
    	position = input[1].pos.xyz + input[1].norm*min((i+apicePhase),extrLenght1)*lenght;
    	position += float3(	inoise(float4(position*noisePosScale,time)),
    						inoise(float4(position*noisePosScale,time+354.25)),
    						inoise(float4(position*noisePosScale,time-63.2))) * pow(min((i+apicePhase),extrLenght1) * invMaxExtrSegm, 0.5) * noiseOffsetScale ;

    	
        output.pos = mul( float4(position,1.0), tWVP );
    	
        output.uv = pow(abs(i* invMaxExtrSegm)+apicePhase*invMaxExtrSegm, .8);
        SpriteStream.Append(output);
    }
    SpriteStream.RestartStrip();
}


float4 PS_Tex(psIn input): SV_Target
{
	return cAmb*float4(input.uv.xxx,1);
}
/*
technique10 ExtrudeConstantLenght
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VSBuffer() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS_extrude1() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Tex() ) );
	}
} 
*/
technique10 ExtrudeDynamicLenght
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VSBuffer() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS_extrude2() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Tex() ) );
	}
} 



 
