
struct data
{
	float3 pos;
	float3 vel;
	float energy;
	uint tag;
};
RWStructuredBuffer<data> Output : BACKBUFFER;

//==========

float velDamp = 0.9;
float3 g;

// --------------------------------
// Brownian:

float brownian = 0;
int offset;
int particlesCount;
StructuredBuffer<float4> random;

#include "noiseFunction.fxh"

// =============================================================================
// SIMULATION:

[numthreads(256, 1, 1)]
void simCS( uint3 DTid : SV_DispatchThreadID )
{
	float4 rnd = random[DTid.x];
	float3 prevPos = Output[DTid.x].pos;
	float3 prevVel = Output[DTid.x].vel;
			
	// BROWNIAN:
	float3 brwn = random[(DTid.x+offset*2)%particlesCount].xyz * brownian;
	
	Output[DTid.x].vel = prevVel*velDamp + g + brwn;
	Output[DTid.x].pos = prevPos + Output[DTid.x].vel;
}

//==============================================================================
//==============================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, simCS() ) );
	}
}
