float4x4 tWVP: WORLDVIEWPROJECTION;
float4x4 tVI : VIEWINVERSE;

float3 g_positions[4]: IMMUTABLE =
{
	float3( -1, 1, 0 ),
	float3( 1, 1, 0 ),
	float3( -1, -1, 0 ),
	float3( 1, -1, 0 ),
} ;
float2 g_texcoords[4]: IMMUTABLE = 
{ 
	float2(0,1), 
	float2(1,1),
	float2(0,0),
	float2(1,0),
};

float size = 1;
float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };

struct vsInBuffer
{
	float4 posO : POSITION ;
	uint iv : SV_VertexID;
};

struct gsIn
{
    float4 pos: POSITION ;
}; 

struct psIn
{
	float4 pos: SV_POSITION;
    float2 uv: TEXCOORD01 ;
};


gsIn VSBuffer(vsInBuffer input)
{
    gsIn output;
    output.pos  = input.posO;

    return output;
}

[maxvertexcount(4)]
void GS_Particle(point gsIn input[1], inout TriangleStream<psIn> SpriteStream)
{
    psIn output;
    for(int i=0; i<4; i++)
    {
        float3 position = g_positions[i]*size;
        position = mul( position, (float3x3)tVI ) + input[0].pos.xyz;
        output.pos = mul( float4(position,1.0), tWVP );
        output.uv = g_texcoords[i];
        SpriteStream.Append(output);
    }
    SpriteStream.RestartStrip();
}


float4 PS_Tex(psIn input): SV_Target
{
	return cAmb;
}

technique10 RenderSpriteBufferTextured
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VSBuffer() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS_Particle() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Tex() ) );
	}
} 



 
