
int ringLength = 1;
float currentTime;
int ringBufferPhase;

struct data
{
	float3 pos;
	float bornTime;
};
RWStructuredBuffer<data> Output : BACKBUFFER;

StructuredBuffer<float3> emitterPos;

[numthreads(1, 1, 1)]
void headsCS( uint3 DTid : SV_DispatchThreadID )
{	
	uint id = (DTid.x * ringLength) + ringBufferPhase;
	
	Output[id].pos = emitterPos[DTid.x];
	Output[id].bornTime = currentTime;
}

[numthreads(128, 1, 1)]
void resetCS( uint3 DTid : SV_DispatchThreadID )
{		
	Output[DTid.x].pos = float3(9999, 9999, 9999);
	Output[DTid.x].bornTime = currentTime;
}

//==============================================================================
//==============================================================================
//==============================================================================

technique11 setRingBuffer
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, headsCS() ) );
	}
}

technique11 resetBin
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, resetCS() ) );
	}
}
