//@author: dottore
//@help: structured buffer template
//@tags: template
//@credits: 

//==============================================================================
//PARAMETERS ===================================================================
//==============================================================================

struct data
{
	float3 pos;
	float3 vel;
	float energy;
	uint tag;
};
RWStructuredBuffer<data> Output : BACKBUFFER;

float3 gravity;
float damping = 1;

// =============================================================================
// SIMULATION:

[numthreads(256, 1, 1)]
void simCS( uint3 DTid : SV_DispatchThreadID )
{
	float3 prevPos = Output[DTid.x].pos;
	float3 prevVel = Output[DTid.x].vel;
	prevVel *= damping;
			
	
	Output[DTid.x].vel = prevVel + gravity;
	Output[DTid.x].pos = prevPos + Output[DTid.x].vel;
}

//==============================================================================
//==============================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, simCS() ) );
	}
}
