
//Threshold:
float threshold = 0.5;
float InputMax = 1;

//Select:
float select = 1;
#define sel (select-1)

struct bins
{
	float value;
	int index;
};
AppendStructuredBuffer<bins> gOutput : BACKBUFFER;

StructuredBuffer<float> Input;

// =============================================================================
// THRESHOLD:

[numthreads(16, 1, 1)]
void appendCS_01( uint3 DTid : SV_DispatchThreadID )
{	

	float value = Input[DTid.x];
	
	bins Out ;
	
	if(value>threshold)
	{
		Out.value = value;
		Out.index = DTid.x;
		gOutput.Append(Out);	
	}

}


// =============================================================================
// SIMPLE SELECT:

[numthreads(16, 1, 1)]
void appendCS_02( uint3 DTid : SV_DispatchThreadID )
{	

	float value = Input[DTid.x];
	
	bins Out ;
	
	if(value>threshold)
	{
		for (int i = 0; i < select; i++)
		{
			Out.value = value;
			Out.index = DTid.x;
			gOutput.Append(Out);	
		}
	}

}

// =============================================================================
// SELECT DEPENDING ON VALUE:

[numthreads(16, 1, 1)]
void appendCS_03( uint3 DTid : SV_DispatchThreadID )
{	

	float value = Input[DTid.x];
	
	bins Out ;
	
	if(value>threshold)
	{
		int count = (sel * value/InputMax) +1;
		for (int i = 0; i < count; i++)
		{
			Out.value = value;
			Out.index = DTid.x;
			gOutput.Append(Out);	
		}
	}

}

//==============================================================================
//==============================================================================
//==============================================================================

technique11 Threshold
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, appendCS_01() ) );
	}
}

technique11 Threshold_SelectFix
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, appendCS_02() ) );
	}
}

technique11 Threshold_SelectDynamic
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, appendCS_03() ) );
	}
}



