
int lineLength = 1;

struct posVel
{
	float3 pos;
	float3 vel;
};
StructuredBuffer<posVel> Input;
StructuredBuffer<uint> perGroupOffset;

RWTexture2D<float4> OutputTexture :BACKBUFFER;
RWStructuredBuffer<posVel> OutputBuffer : BACKBUFFER;

// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================

[numthreads(128, 1, 1)]
void WriteTextureCS(uint3 DTid : SV_DispatchThreadID )
{
	uint traceID = DTid.x / lineLength;
	uint traceSegmID = DTid.x % lineLength;
	int index = (traceSegmID + perGroupOffset[traceID]) % lineLength + traceID * lineLength;
		
	OutputTexture[float2(traceSegmID, traceID)] = 
	float4(Input[index].pos,1);
	
	OutputTexture[float2(traceSegmID, traceID)] = 
	float4(Input[index].pos,1);
	
}

[numthreads(128, 1, 1)]
void WriteBufferCS(	uint3 DTid : SV_DispatchThreadID )
{
	uint traceID = DTid.x / lineLength;
	uint traceSegmID = DTid.x % lineLength;
	int index = (traceSegmID + perGroupOffset[traceID]) % lineLength + traceID * lineLength;
		
	OutputBuffer[DTid.x] = Input[index];
}

// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================
// =============================================================================

technique11 Buffer_Reordered_to_texture
{
	pass P0
	{
		SetComputeShader(CompileShader( cs_5_0, WriteTextureCS() ) );
	}
}

technique11 Buffer_Reordered_to_buffer
{
	pass P0
	{
		SetComputeShader(CompileShader( cs_5_0, WriteBufferCS() ) );
	}
}