//@author: dottore
//@help: structured buffer template
//@tags: template
//@credits: 

//==============================================================================
//PARAMETERS ===================================================================
//==============================================================================

RWStructuredBuffer<uint2> Output : BACKBUFFER;

int count;

// =============================================================================
// SIMULATION:

[numthreads(128, 1, 1)]
void CS( uint3 DTid : SV_DispatchThreadID )
{
	if(DTid.x > (uint)count*(uint)count) return;

	uint A = floor(DTid.x / (uint)count);
	uint B = DTid.x % count;
	
	Output[DTid.x] = uint2(A, B);
}

//==============================================================================
//==============================================================================
//==============================================================================

technique11 Cross_Indices
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}
