//@author: dottore
//@help: append buffer template
//@tags: template
//@credits: 

AppendStructuredBuffer<uint2> gOutput : BACKBUFFER;

StructuredBuffer<uint2> pairsID;
StructuredBuffer<float3> pos;

float minDist <string uiname="min distance";>;
float maxDist <string uiname="max distance";> = 10;

bool inclUp <string uiname="include upper";> = 1;
bool inclLow <string uiname="include lower";> = 1;
bool inclEq <string uiname="include equal";> = 1;

// =============================================================================
// SELECT DEPENDING ON VALUE:

[numthreads(64, 1, 1)]
void CS_03( uint3 DTid : SV_DispatchThreadID )
{	
	uint count,dummy;
	pos.GetDimensions(count,dummy);
	uint sqrCount = count*count;
	
	if(DTid.x >= sqrCount) return;
	
	// Input Mapping:
	uint2 pairs =  pairsID[DTid.x];
	
	//if(pairs.x < pairs.y) return;

	if(pairs.x < pairs.y && !inclUp) return;
	if(pairs.x > pairs.y && !inclLow) return;
	if(pairs.x == pairs.y && !inclEq) return;

	float3 posA = pos[pairs.x];		
	float3 posB = pos[pairs.y];
	
	float dist = distance(posA, posB);
	
	if(dist>=minDist && dist<maxDist)
	gOutput.Append(pairs);	


}

//==============================================================================
//==============================================================================
//==============================================================================

technique11 DistanceThreshold
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS_03() ) );
	}
}



